.include "2313def.inc"

.equ	INPUT		=0		;IK Receiver position (PD0)



.def	SYS_ADDR	=R26		;The system address


.def	S		=R0

.def	inttemp		=R1

.def	ref1		=R2

.def	ref2		=R3



.def	temp		=R16



.def	timerL		=R17

.def	timerH		=R16



.def	system		=R19

.def	command		=R20



.def	bitcnt		=R21

.def	RELE		=R18		;OUTPUT Word to PRORTB
.def	temp		=R22		;Counter
.def	flag		=R23		;Flag


;======================== *** SRAM SEGMENT ***==============================

	.DSEG  				;SRAM memory segment
FCODE:	.byte	1

;======================== *** CODE SEGMENT ***==============================

	.CSEG     	 		;begin of program memory
	.org 0
;-----------------SETUP INTERRUPTS HANDLERS---------------------------------

reset:	rjmp	start			; 00 Reset Handler
	reti				; 01 IRQ0 Handler
	reti				; 02 IRQ1 Handler
	reti				; 03 Timer1 Capture Handler
	reti				; 04 Timer1 Compare Handler
	reti				; 05 Timer1 Overflow Handler
	rjmp	TIM0_OVF		; 06 Timer0 Overflow Handler
	reti				; 07 UART RX Complete Handler
	reti				; 08 UDR Empty Handler
	reti				; 09 UART TX Complete Handler
	reti				; 0A Analog Comparator Handler
	
;--------------------- Messages & Constants --------------------------------

DATA:	.db	0xAA,0xAA,0xAA,0xAA
	.db	0xAA,0xAA,0xAA,0xAA
	.db	0xAA,0xAA,0xAA,0xAA
	.db	0xAA,0xAA,0xAA,0xAA
	.db	0xAA,0xAA,0xAA,0xAA	
	.db	0xAA,0xAA,0xAA,0xAA
	.db	0xAA,0xAA,0xAA,0xAA	
	.db	0xAA,0xAA,0xAA,0xAA

;----------------------- BEGIN OF PROGRAMM ---------------------------------

;---------------------- *** setup part *** ---------------------------------

start:	ldi	r16,0xdf		;stack init SP=0xdf
	out	spl,r16

	sbi	ACSR,ACD		;Analog comparator off

	ldi	r16,0xFF		;Set Ini Ports func (DIRECTION)
	out	ddrb,r16		;	DDRB

	ldi	r16,0x00		;Set Ini Ports value (VALUE)
	out	portb,r16		;	PORTB

	ldi	r16,0x00		;Set Ini Ports func (DIRECTION)
	out	ddrd,r16		;	DDRD

	ldi	r16,0b11111110		;Set Ini Ports value (VALUE)
	out	portd,r16		;	PORTD

	ldi	r16,0b00000001
	out	TCCR0,r16		;T/C0 to CK ()
	ldi	r16,0b00000010
	out	TIMSK,r16		;T/C0 Overflow INT enable

;--------------------- Registers clearing ----------------------------------

	ldi	r31,0x00		;Load 0=>MSB (Z)
	ldi	r30,0x1d		;Load 29=>LSB (Z)
RgClr:	st	Z,R31			;0=>R(Z)
	dec	R30			;Counter=counter-1
	brne	RgClr			;Do until counter=0

;---------------------- Main program ---------------------------------------
	
		sei				;global INT enable	
		
			
		in	temp,PIND		;Read setup Jumpers (ADRESS)state
		andi	temp,0b00001110	;Remove spare bits
		
		cpi	temp,0b00000000	;ADRESS 1
		breq	ADR1			;Jump to ADR1 subroutine 
		cpi	temp,0b00000010	;ADRESS 2
		breq	ADR2			;Jump to ADR2 subroutine
		cpi	temp,0b00000100	;ADRESS 3
		breq	ADR3			;Jump to ADR3 subroutine 
		cpi	temp,0b00000110	;ADRESS 4
		breq	ADR4			;Jump to ADR4 subroutine 
		cpi	temp,0b00001000	;ADRESS 5
		breq	ADR5			;Jump to ADR5 subroutine 
		cpi	temp,0b00001010	;ADRESS 6
		breq	ADR6			;Jump to ADR6 subroutine 
		cpi	temp,0b00001100	;ADRESS 7
		breq	ADR7			;Jump to ADR7 subroutine 
		cpi	temp,0b00001110	;ADRESS 8
		breq	ADR8			;Jump to ADR8 subroutine  
	
ADR1:		ldi	SYS_ADDR,24		;System adress = 24
		rjmp	main
ADR2:		ldi	SYS_ADDR,25		;System adress = 25
		rjmp	main
ADR3:		ldi	SYS_ADDR,26		;System adress = 26
		rjmp	main
ADR4:		ldi	SYS_ADDR,27		;System adress = 27
		rjmp	main
ADR5:		ldi	SYS_ADDR,28		;System adress = 28
		rjmp	main
ADR6:		ldi	SYS_ADDR,29		;System adress = 29
		rjmp	main
ADR7:		ldi	SYS_ADDR,30		;System adress = 30
		rjmp	main
ADR8:		ldi	SYS_ADDR,31		;System adress = 31
		rjmp	main


main:		rcall	detect			;Call RC5 detect routine

		;clr	RELE


		cp	system,SYS_ADDR	;Respponds only at the specified address

		brne	Repeat



		andi	command,0x3F		;Remove control bit


		cpi	command,0b00111000	;Code 1
		breq	CODE11			;Jump to CODE1 subroutine 
		cpi	command,0b00111001	;Code 2
		breq	CODE22			;Jump to CODE2 subroutine 
		cpi	command,0b00111010	;Code 3
		breq	CODE33			;Jump to CODE3 subroutine 
		cpi	command,0b00111011	;Code 4
		breq	CODE44			;Jump to CODE4 subroutine 
		cpi	command,0b00111100	;Code 5
		breq	CODE55			;Jump to CODE5 subroutine 
		cpi	command,0b00111101	;Code 6
		breq	CODE66			;Jump to CODE6 subroutine 
		cpi	command,0b00111110	;Code 7
		breq	CODE77			;Jump to CODE7 subroutine 
		cpi	command,0b00111111	;Code 8
		breq	CODE88			;Jump to CODE8 subroutine 
		
		rjmp	Repeat			;If error goto END and start again

CODE11:		rjmp	CODE1			;
CODE22:		rjmp	CODE2			;	
CODE33:		rjmp	CODE3			;
CODE44:		rjmp	CODE4			;
CODE55:		rjmp	CODE5			;
CODE66:		rjmp	CODE6			;	
CODE77:		rjmp	CODE7			;
CODE88:		rjmp	CODE8			;Call CODEx subrotines

		
Repeat:		out	PORTB,RELE		;RELE Out to PORTB
		rjmp	main			;JMP MAIN



.include "TIM0_OVF.asm"
.include "detect.asm"
.include "CODE1.asm"
.include "CODE2.asm"
.include "CODE3.asm"
.include "CODE4.asm"
.include "CODE5.asm"
.include "CODE6.asm"
.include "CODE7.asm"
.include "CODE8.asm"